#include "file_pager.h"

/* Initialise a pager for a file with a unique file identifier and shared page
   mapper for moderating access to loaded pages. */

FilePager::FilePager(fileid_t fileid, PageMapper *mapper)
: Pager(mapper), fileid(fileid)
{
}

long FilePager::mmap(size_t position, size_t length, size_t *start_pos, size_t *end_pos, size_t *data_end)
{
    /* Set the limits of the paged region. */

    Pager::mmap(position, length, start_pos, end_pos, data_end);

    /* Obtain the amount of the region that is populated with file data. */

    *data_end = get_data_size() - _start;

    if (*data_end > _size)
        *data_end = _size;

    return L4_EOK;
}

// vim: tabstop=4 expandtab shiftwidth=4
